#!/usr/bin/perl -w


=comment


TODO:
* Tbb ember
* Szintek lersa (golyk eloszlsa, sebessg)
* Pontozs, szintlps
* letek szma

On original Super Pang graphics:
GFXSET 0 : Backgrounds, Font

PALETTES:
0 : 
1 : Player 2 (narancs)
2 : Player 1 (kk)
3 : Kk szigony
4 : narancs szigony
5 : Zld golyk
6 : Kk golyk
7 : 
8 : 
9 : Stt narancssrga golyk (?)
A : Stt piros golyk
B : 
C : Gymlcsk
D : 
E : Narancssrga golyk
F : Piros golyk

=cut

use strict;
use SDL;
use SDL::App;
use SDL::Event;
use SDL::Surface;
use SDL::Timer;
use SDL::Palette;
use SDL::Sound;
use SDL::Mixer;
use SDL::Font;

use vars qw ( $App $Background 
  @GameObjects $GamePause $GameLevel $GameLevelDesc $SpawnDelay %GameEvents
  $HexaSurface $DarkHexaSurface
  $BallSurface $DarkBallSurface 
  $GuySurface $HarpoonSurface $PopSurface $BorderSurface
  %Sounds $Mixer
  @BallDesc @GameLevels
  $ScreenHeight $ScreenWidth $PhysicalScreenWidth $PhysicalScreenHeight $ScreenMargin
  %Keys %Events $GameSpeed );
  
##########################################################################
# GLOBAL CONFIGURATION
##########################################################################

%Sounds = (
  'pop' => 'pop.voc',
  'shoot' => 'sound044.voc',
  'death' => 'meow.voc',
);

@BallDesc = (
  { 'name' => 'n0', 'spawndelay' =>   1, 'width' => 128, 'height' =>106, 'speedY' => 6.5, 'popIndex' => 0,
    'rect' => new SDL::Rect(-x => 0, -y => 12, -width => 128, -height => 106) },
  { 'name' => 'n1', 'spawndelay' => 0.8, 'width' =>  96, 'height' => 80, 'speedY' => 5.7, 'popIndex' => 1,
    'rect' => new SDL::Rect(-x => 128, -y => 8, -width => 96, -height => 80) },
  { 'name' => 'n2', 'spawndelay' => 0.6, 'width' =>  64, 'height' => 53, 'speedY' => 5, 'popIndex' => 2,
    'rect' => new SDL::Rect(-x => 0, -y => 134, -width => 64, -height => 53) },
  { 'name' => 'n3', 'spawndelay' => 0.4, 'width' =>  32, 'height' => 28, 'speedY' => 4, 'popIndex' => 3,
    'rect' => new SDL::Rect(-x => 224, -y => 2, -width => 32, -height => 28) },
  { 'name' => 'n4', 'spawndelay' => 0.2, 'width' =>  16, 'height' => 15, 'speedY' => 3, 'popIndex' => 4,
    'rect' => new SDL::Rect(-x => 232, -y => 42, -width => 16, -height => 15) },
  
  { 'name' => 'b0', 'spawndelay' => 0.7, 'width' =>  64, 'height' => 52, 'speedY' => 5.7, 'popIndex' => 2,
    'rect' => new SDL::Rect(-x => 160, -y => 166, -width => 64, -height => 52) },
  { 'name' => 'b1', 'spawndelay' => 0.3, 'width' =>  32, 'height' => 28, 'speedY' => 5, 'popIndex' => 3,
    'rect' => new SDL::Rect(-x => 224, -y => 66, -width => 32, -height => 28) },
  { 'name' => 'b2', 'spawndelay' => 0.2, 'width' =>  16, 'height' => 14, 'speedY' => 4.2, 'popIndex' => 4,
    'rect' => new SDL::Rect(-x => 232, -y => 106, -width => 16, -height => 14) },
  
  { 'name' => 'h0', 'spawndelay' => 0.8, 'width' =>  64, 'height' => 52, 'popIndex' => 5, 'hexa' => 1,
    'rect' => new SDL::Rect(-x => 0, -y => 6, -width => 64, -height => 52),
    'magicrect' => new SDL::Rect(-x => 0, -y => 102, -width => 64, -height => 52), },
  { 'name' => 'h1', 'spawndelay' => 0.4, 'width' =>  32, 'height' => 28, 'popIndex' => 6, 'hexa' => 1,
    'rect' => new SDL::Rect(-x => 0, -y => 66, -width => 32, -height => 28),
    'magicrect' => new SDL::Rect(-x => 0, -y => 162, -width => 32, -height => 28), },
  { 'name' => 'h2', 'spawndelay' => 0.2, 'width' =>  16, 'height' => 14, 'popIndex' => 7, 'hexa' => 1,
    'rect' => new SDL::Rect(-x => 192, -y => 65, -width => 16, -height => 14),
    'magicrect' => new SDL::Rect(-x => 9, -y => 200, -width => 16, -height => 14), },
);
$BallDesc[0]->{nextgen} = $BallDesc[1];
$BallDesc[1]->{nextgen} = $BallDesc[2];
$BallDesc[2]->{nextgen} = $BallDesc[3];
$BallDesc[3]->{nextgen} = $BallDesc[4];

$BallDesc[5]->{nextgen} = $BallDesc[6];
$BallDesc[6]->{nextgen} = $BallDesc[7];

$BallDesc[8]->{nextgen} = $BallDesc[9];
$BallDesc[9]->{nextgen} = $BallDesc[10];

@GameLevels = (
  { 'gamespeed' => 1, 'spawndelay' => 12, 
    'balls' => [ qw(n0 n0 b0 b0 b1 b1 b2 n1 n1 n1 n1 n1 n1 n1 n2 n2 n2 n3 n4 h0 h1 h1 h1) ], }
);
	

$PhysicalScreenWidth = 800;
$PhysicalScreenHeight = 600;
$ScreenMargin = 16;
$ScreenWidth = $PhysicalScreenWidth - $ScreenMargin * 2;
$ScreenHeight = int( ($PhysicalScreenHeight - $ScreenMargin * 2 - 70) / 32 ) * 32;


##########################################################################
# GAME OBJECT CLASSES
##########################################################################

package Ball;
package DarkBall;
package Guy;
package Harpoon;
package Pop;



##########################################################################
package GameObject;
##########################################################################

sub new {
  my ($class) = @_;
  my $self = {
    'rect' => new SDL::Rect( -x => 0, -y => 0, -width => 0, -height => 0 ),
    'speedX' => 0,
    'speedY' => 0,
    'x' => 0,
    'y' => 0,
    'w' => 10,
    'h' => 10,
  };
  bless $self, $class;
}

sub Delete {
  my $self = shift;
  my ($i);
  
  for ($i = 0; $i < scalar @::GameObjects; ++$i) {
    if ($::GameObjects[$i] eq $self) {
      splice @::GameObjects, $i, 1;
      last;
    }
  }
  $self->Clear();
}

sub Advance {
}

sub Clear {
  my ($self) = @_;
  $::Background->blit($self->{rect}, $::App, $self->{rect});
  #$::App->fill( $self->{rect}, new SDL::Color() );
}

sub TransferRect {
  my ($self) = @_;
  
  $self->{rect}->x($self->{x} + $::ScreenMargin);
  $self->{rect}->y($self->{y} + $::ScreenMargin);
  $self->{rect}->width($self->{w});
  $self->{rect}->height($self->{h});
}

sub Draw {
  my ($self) = @_;
  
  $self->TransferRect();
  $::App->fill( $self->{rect}, new SDL::Color(-r => 0x80) );
}



##########################################################################
package Ball;
##########################################################################

@Ball::ISA = qw(GameObject);
$Ball::Gravity = 0.05;
$Ball::MagicBallRect = new SDL::Rect(-x => 232, -y => 138, -width => 16, -height => 15);

for (my $i=0; $i < 8; ++$i) {
  my $desc = $::BallDesc[$i];
  $desc->{bounceY} = $desc->{speedY} * $desc->{speedY} / $Ball::Gravity / 2;
}

sub Create {
  my ($description, $x, $y, $dir) = @_;
  return new Hexa(@_) if ($description->{hexa});
  return new Ball(@_);
}


sub new {
  my ($class, $description, $x, $y, $dir) = @_;
  my ($self);
  
  $self = new GameObject;
  %{$self} = ( %{$self},
    'x' => $x,
    'y' => $y,
    'w' => $description->{width},
    'h' => $description->{height},
    'anim' => 0,
    'hexa' => $description->{hexa} ? 1 : 0,
    'desc' => $description,
    'hasmagic' => 0,		# true if one of the ball's descendants is magic
    'ismagic' => 0,			# true if the ball IS magic
  );
  $self->{speedX} = $dir > 0 ? 1.3 : -1.3;
  
  bless $self, $class;
}

sub Advance {
  my ($self) = @_;
  
  ++$self->{anim};
  unless( $::GamePause > 0 ) {
    $self->{speedY} += $Ball::Gravity * $::GameSpeed unless ($self->{hexa});
    $self->{x} += $self->{speedX} * $::GameSpeed;
    $self->{y} += $self->{speedY} * $::GameSpeed;
    if ($self->{y} > $::ScreenHeight - $self->{h}) {
        $self->{y} = $::ScreenHeight - $self->{h};
      if ($self->{hexa}) {
        $self->{speedY} = -abs($self->{speedY});
      } else {
        $self->{speedY} = -$self->{desc}->{speedY};
      }
    }
    if ($self->{y} < 0) {
      $self->{y} = 0;
      $self->{speedY} = abs($self->{speedY});
    }
    if ($self->{x} < 0) {
      $self->{x} = 0;
      $self->{speedX} = abs( $self->{speedX} );
    }
    if ($self->{x} > $::ScreenWidth - $self->{w}) {
      $self->{x} = $::ScreenWidth - $self->{w};
      $self->{speedX} = -abs( $self->{speedX} );
    }
  }
  
  $self->CheckCollisions();
}

sub CheckCollisions {
  my $self = shift;  
  my ($gameObject);
  
  foreach $gameObject (@::GameObjects) {
    if ( ref $gameObject eq 'Harpoon' ) {
      if ($self->Collisions($gameObject)) {
        $self->Pop;
        $gameObject->Delete();
        last;
      }
    }
    elsif ( ref $gameObject eq 'Guy' ) {
      if ($::GamePause <= 0 and $self->Collisions($gameObject)) {
        $gameObject->Kill();
      }
    }
  }
}

sub Draw {
  my ($self) = @_;
  
  $self->TransferRect();
  if ($self->{ismagic} and int($self->{anim}/4) % 2) {
    $::BallSurface->blit( $Ball::MagicBallRect, $::App, $self->{rect} )
  } else {
    $::BallSurface->blit( $self->{desc}->{rect}, $::App, $self->{rect} );
  }
}

sub Collisions {
  my ($self, $other) = @_;
  
  # Bounding box detection
  
  return 0 if $self->{x} >= $other->{x} + $other->{w};
  return 0 if $other->{x} >= $self->{x} + $self->{w};
  return 0 if $self->{y} >= $other->{y} + $other->{h};
  return 0 if $other->{y} >= $self->{y} + $self->{h};
  
  # Circle vs rectangle collision
  
  my ($centerX, $centerY, $boxAxisX, $boxAxisY, $boxCenterX, $boxCenterY, $distSquare, $distance);
  $boxAxisX = ($other->{collisionw} or $other->{w}) / 2;
  $boxAxisY = ($other->{collisionh} or $other->{h}) / 2;
  $boxCenterX = $other->{x} + $other->{w} / 2;
  $boxCenterY = $other->{y} + $other->{h} / 2;
  $centerX = $self->{x} + $self->{w} / 2;
  $centerY = $self->{y} + $self->{h} / 2;
  
  # Translate coordinates to the box center
  $centerX -= $boxCenterX;
  $centerY -= $boxCenterY;  
  $centerX = abs($centerX);
  $centerY = abs($centerY);
  
  if ($centerX < $boxAxisX) {
    return 1 if $centerY < $boxAxisY + $self->{h} / 2;
    return 0;
  }
  if ($centerY < $boxAxisY) {
    return 2 if $centerX < $boxAxisX + $self->{w} / 2;
    return 0;
  }
  $distSquare = ($centerX-$boxAxisX) * ($centerX-$boxAxisX);
  $distSquare+= ($centerY-$boxAxisY) * ($centerY-$boxAxisY);
  return 3 if $distSquare < $self->{w} * $self->{h} / 4;
  
  return 0;
}

sub Pop {
  my $self = shift;
  
  ::PlaySound('pop');
  $::GameEvents{'magic'} = 1 if ($self->{ismagic});
  
  if ($self->{desc}->{nextgen}) {
    my @children = $self->SpawnChildren;
    $self->AdjustChildren(@children);
    push @::GameObjects, (@children);
  }
  push @::GameObjects, (new Pop($self->{x}, $self->{y}, $self->{desc}->{popIndex}));
  
  $self->Delete();
}

sub SpawnChildren {
  my $self = shift;
  my ($nextgen, $child1, $child2, $x, $y);
  
  $nextgen = $self->{desc}->{nextgen};
  $x = $self->{x} + $self->{w} / 2;
  $y = $self->{y} + ( $self->{h} - $nextgen->{height} ) / 2;

  $child1 = &Create($nextgen, $x - $nextgen->{width}, $y, 0);
  $child2 = &Create($nextgen, $x, $y, 1);
  if ($self->{hasmagic}) {
    (rand(50) > 25 ? $child1 : $child2)->GiveMagic();
  }
  return ($child1, $child2);
}

sub AdjustChildren {
  my $self = shift;
  my ($nextgen, $child1, $child2, $speedY, $altitude);
  
  $nextgen = $self->{desc}->{nextgen};
  $altitude = $::ScreenHeight - $self->{y} - $self->{h};
  if ($altitude > $nextgen->{bounceY}) {
    $speedY = 1.8;
  } else {
    $speedY = 1.8;
    while ($speedY * $speedY / $Ball::Gravity / 2 + $altitude < $nextgen->{bounceY}) {
      ++$speedY;
    }
  }

  $_[0]->{speedY} = -$speedY;
  $_[1]->{speedY} = -$speedY;
}

sub GiveMagic {
  my $self = shift;
  
  $self->{hasmagic} = 1;
  $self->{ismagic} = 1 unless $self->{desc}->{nextgen};
}



##########################################################################
package Hexa;
##########################################################################

@Hexa::ISA = qw(Ball);

sub new {
  my $class = shift;
  my ($self);
  
  $self = new Ball(@_);
  $self->{speedX} = (rand(1.25) + 1.25) * ($self->{speedX} > 0 ? 1 : -1);
  $self->{speedY} = -4 + abs($self->{speedX});
  
  bless $self, $class;
}

sub Draw {
  my $self = shift;
  my ($rect, $srcx);
  
  $self->TransferRect();
  if ($self->{ismagic} and int($self->{anim} / 3) % 3 == 0) {
    $::HexaSurface->blit($self->{desc}->{magicrect}, $::App, $self->{rect});
  } else {
    $rect = $self->{desc}->{rect};
    $srcx = (int($self->{anim} / 3) % 3) * $self->{w};
    $rect->x( $rect->x + $srcx );
    $::HexaSurface->blit( $rect, $::App, $self->{rect} );
    $rect->x( $rect->x - $srcx );
  }
}

sub AdjustChildren {
}


##########################################################################
package DarkBall;
##########################################################################

@DarkBall::ISA = qw(GameObject);

sub new {
  my ($class, $description, $x, $dir) = @_;
  
  my $self = new GameObject;
  %{$self} = ( %{$self},
    'x' => $x,
    'y' => -$description->{height},
    'w' => $description->{width},
    'h' => $description->{height},
    'desc' => $description,
    'delay' => 0,
    'dir' => $dir,
  );
  bless $self, $class;
}

sub Advance {
  my $self = shift;
  
  return if $::GamePause > 0;
  --$self->{delay};
  if ($self->{delay} < 0) {
    $self->{y} += 16;
    $self->{delay} = 50 / $::GameSpeed;
    if ($self->{y} >= 0) {
      my $ball = Ball::Create( $self->{desc}, $self->{x}, $self->{y}, $self->{dir} );
      $ball->GiveMagic;
      push @::GameObjects, ( $ball );
      $self->Delete();
    }
  }
}

sub Draw {
  my $self = shift;
  my ($surface);
  
  $self->TransferRect();
  $surface = $self->{desc}->{hexa} ? $::DarkHexaSurface : $::DarkBallSurface;
  $surface->blit( $self->{desc}->{rect}, $::App, $self->{rect} );
}



##########################################################################
package Pop;
##########################################################################

@Pop::ISA = qw(GameObject);

@Pop::Description = (
  { 'hexa' => 0, 'xoffset' => 0, 'yoffset' => 12, 'srcx' =>   0, 'srcy' =>   0, 'size' => 128, },
  { 'hexa' => 0, 'xoffset' => 0, 'yoffset' =>  8, 'srcx' =>   0, 'srcy' => 128, 'size' =>  96, },
  { 'hexa' => 0, 'xoffset' => 0, 'yoffset' =>  6, 'srcx' =>   0, 'srcy' => 224, 'size' =>  64, },
  { 'hexa' => 0, 'xoffset' => 0, 'yoffset' =>  2, 'srcx' => 256, 'srcy' => 224, 'size' =>  32, },
  { 'hexa' => 0, 'xoffset' =>-8, 'yoffset' => -8, 'srcx' => 256, 'srcy' => 256, 'size' =>  32, },
  
  { 'hexa' => 1, 'xoffset' => 0, 'yoffset' => -6, 'srcx' =>   0, 'srcy' =>  96, 'size' =>  64, },
  { 'hexa' => 1, 'xoffset' => 0, 'yoffset' => -4, 'srcx' =>   0, 'srcy' => 160, 'size' =>  32, },
  { 'hexa' => 1, 'xoffset' =>-8, 'yoffset' => -6, 'srcx' =>   0, 'srcy' => 192, 'size' =>  32, },
);

sub new {
  my ($class, $x, $y, $index) = @_;
  my ($self, $desc);
  
  $desc = $Pop::Description[$index],
  $self = new GameObject;
  %{$self} = ( %{$self},
    'x' => $x + $desc->{xoffset},
    'y' => $y + $desc->{yoffset},
    'w' => $desc->{size},
    'h' => $desc->{size},
    'desc' => $desc,
    'anim' => 0,
  );
  bless $self, $class;
}

sub Advance {
  my $self = shift;
  
  ++$self->{anim};
  if ($self->{anim} >= 20) {
    $self->Delete();
  }
}

sub Draw {
  my $self = shift;
  my ($phase, $surface, $srcrect);
  
  $self->TransferRect();
  $phase = int($self->{anim} / 5);
  $phase = 3 if $phase > 3;
  
  $srcrect = new SDL::Rect(
    -x => $self->{desc}->{srcx} + $phase * $self->{w},
    -y => $self->{desc}->{srcy},
    -width => $self->{w},
    -height => $self->{h} );
  $surface = $self->{desc}->{hexa} ? $::HexaSurface : $::PopSurface;
  $surface->blit( $srcrect, $::App, $self->{rect} );
}


##########################################################################
package GamePause;
##########################################################################

@GamePause::ISA = qw(GameObject);

sub new {
  my ($class) = @_;
  
  my $self = new GameObject;
  my ($width);
  $width = ::SDL_TEXTWIDTH("Time left: 9.999");  
  
  %{$self} = ( %{$self},
    'x' => ($::PhysicalScreenWidth - $width) / 2,
    'y' => 100,
    'w' => $width,
    'h' => 32,
  );
  $self->TransferRect();
  bless $self, $class;
}

sub Advance {
  my $self = shift;
  
  if ($::GamePause <= 0) {
    $self->Delete;
  }
}

sub Draw {
  my $self = shift;
  
#  $::App->fill($self->{rect}, new SDL::Color(-r=>60));
  $::App->print( $self->{rect}->x, $self->{rect}->y, "Time left: " . ($::GamePause / 100) );
}





##########################################################################
package Guy;
##########################################################################

@Guy::ISA = qw(GameObject);

sub new {
  my ($class, $number) = @_;
  my ($self);
  
  $self = new GameObject;
  %{$self} = ( %{$self},
    'number' => $number,
    'x' => 100 + $number * 100,
    'y' => $::ScreenHeight - 64,
    'w' => 64,
    'h' => 64,
    'collisionw' => '30',
    'collisionh' => '55',
    'delay' => 0,
    'speedY' => 0,
    'speedX' => 0,
    'dir' => $number % 2,
    'state' => 'idle',
    'harpoons' => 0,
    'invincible' => 100,
  );
  bless $self, $class;
}

sub Fire {
  my ($self) = @_;
  
  if ($self->{harpoons} < 2) {
    ++$self->{harpoons};
    unshift @::GameObjects, (new Harpoon($self));
    $self->{state} = 'shoot';
    $self->{delay} = 7;
    ::PlaySound('shoot');
    return 1;
  }
  return 0;
}

sub Advance {
  my ($self) = @_;
  
  --$self->{invincible};
  
  if ($self->{delay} > 0) {
    --$self->{delay};
    return;
  }
  
  $self->{speedX} = 0;
  $self->{state} = 'idle';
  
  if ( $::Events{::SDLK_UP} ) {
    return if $self->Fire();
  }
  if ( $::Keys{::SDLK_LEFT} ) {
    $self->{speedX} = -3;
    $self->{dir} = 0;
    $self->{state} = 'walk';
  } elsif ( $::Keys{::SDLK_RIGHT} ) {
    $self->{speedX} = 3;
    $self->{dir} = 1;
    $self->{state} = 'walk';
  }
  $self->{x} += $self->{speedX};
  
  if ($self->{x} < 0) {
    $self->{x} = 0;
  }
  if ($self->{x} > $::ScreenWidth - $self->{w}) {
    $self->{x} = $::ScreenWidth - $self->{w};
  }
}

sub Draw {
  my ($self) = @_;
  my ($srcrect, $srcx, $srcy, $srcw, $srch);
  
  return if ($self->{invincible} > 0 and int($self->{invincible} / 4) % 2);
  
  $srcw = $srch = 64;
  if ($self->{state} eq 'idle') {
    $srcx = $self->{dir} * 128;
    $srcy = 64;
  } elsif ($self->{state} eq 'walk') {
    $srcx = $self->{dir} * 256 + (int($self->{x} / 16) % 4) * 64;
    $srcy = 0;
  } elsif ($self->{state} eq 'shoot') {
    $srcx = $self->{dir} * 128 + 64;
    $srcx -= 64 if ($self->{delay} <= 1);
    $srcy = 64;
  }
  $srcrect = new SDL::Rect( -width => $srcw, -height => $srch, -x => $srcx, -y => $srcy );
  $self->TransferRect();
  $::GuySurface->blit($srcrect, $::App, $self->{rect});
}

sub Kill {
  my ($self) = @_;
  
  return if $self->{invincible} > 0;
  $self->{killed} = 1;
  $::GameEvents{'kill'} = 1;
}

sub DeleteHarpoons {
  my ($self) = @_;
  my (@gameObjects, $harpoon);
  
  @gameObjects = @::GameObjects;
  foreach my $harpoon (@gameObjects) {
    $harpoon->Delete if ($harpoon->{guy} and $harpoon->{guy} eq $self);
  }
}



##########################################################################
package Harpoon;
##########################################################################

@Harpoon::ISA = qw(GameObject);

sub new {
  my ($class, $guy) = @_;
  my ($self);
  
  $self = new GameObject;
  %{$self} = ( %{$self},
    'x' => $guy->{x} + 22,
    'y' => $::ScreenHeight - 32,
    'w' => 18,
    'h' => 32,
    'anim' => 0,
    'speedY' => -3,
    'speedX' => 0,
    'guy' => $guy,
  );
  bless $self, $class;
}

sub Delete {
  my $self = shift;
  
  --$self->{guy}->{harpoons};
  $self->SUPER::Delete();
}

sub Advance {
  my $self = shift;
  
  $self->{y} += $self->{speedY};
  if ($self->{y} < 0) {
    $self->Delete();
    return;
  }
  $self->{h} = $::ScreenHeight - $self->{y};
  ++$self->{anim};
}

sub Draw {
  my $self = shift;
  my ($x, $y, $h, $maxh, $dstrect, $srcrect);
  
  $self->TransferRect();
  $y = $self->{y};
  $dstrect = new SDL::Rect( -w => $self->{w}, -x => $self->{x} + $::ScreenMargin );
  $srcrect = new SDL::Rect( -w => $self->{w}, 
    -x => (40, 70, 102)[ int($self->{anim} / 4) % 3 ], -y => 0 );
  $maxh = 64;
  
  # The harpoon needs to be drawn from tile pieces.
  # $y iterates from $self->{y} to $::ScreenHeight
  # We draw at most $maxh height tiles at a time.
  
  while ($y < $::ScreenHeight) {
    $h = $::ScreenHeight - $y;
    $h = $maxh if $h > $maxh;
    $dstrect->y( $y + $::ScreenMargin );
    $dstrect->height( $h );
    $srcrect->height( $h );
    $::HarpoonSurface->blit( $srcrect, $::App, $dstrect );
    
    # Prepare for next piece
    $y += $h;
    $srcrect->y( 32 ); # First piece starts at 0, rest start at 32
    $maxh = 32;        # First piece maxheight is 64, rest is 32
  }
}




##########################################################################
package GameTimer;
##########################################################################

use vars qw($FirstTick $LastTick $TotalAdvances);

sub ResetTimer {
  $FirstTick = $::App->ticks;
  $LastTick = $FirstTick;
  $TotalAdvances = 0;
}

sub GetAdvances {
  my ($ticks, $advance);
  
  $ticks = $::App->ticks;
  $advance = int(($ticks - $FirstTick) / 10) - $TotalAdvances;
  $TotalAdvances += $advance;
  return $advance;
}

package main;


##########################################################################
# PALETTE MANIPULATION
##########################################################################


sub RgbToHsi {
  my ($r, $g, $b) = @_;
  my ($min, $max, $delta, $h, $s, $i);
  
  if ($r > $g) { 
    $max = $r > $b ? $r : $b;
    $min = $g < $b ? $g : $b;
  } else {
    $max = $g > $b ? $g : $b;
    $min = $r < $b ? $r : $b;
  }
  $i = ($min + $max) / 2;
  if ($min == $max) {
    return (0, 0, $i);
  }
  
  $delta = ($max - $min);
  if ($i < 128) {
    $s = 255 * $delta / ($min + $max);
  } else {
    $s = 255 * $delta / (511 - $min - $max);
  }
  
  if ($r == $max) {
    $h = ($g - $b) / $delta;
  } elsif ($g == $max) {
    $h = 2 + ($b - $r) / $delta;
  } else {
    $h = 4 + ($r - $g) / $delta;
  }
  $h = $h * 42.5;
  $h += 255 if $h < 0;
  $h -= 255 if $h > 255;
  
  return ($h, $s, $i);
}

sub HsiToRgb {
  my ($h, $s, $i) = @_;
  my ($m1, $m2);
  
  if ($s < 1) {
    $i = int($i + 0.5);
    return ($i, $i, $i);
  }
  
  if ($i < 128) {
    $m2 = ($i * (255 + $s)) / 65025.0;
  } else {
    $m2 = ($i + $s - ($i * $s) / 255.0) / 255.0;
  }
  $m1 = ($i / 127.5) - $m2;

  return (
    &GetHsiValue( $m1, $m2, $h + 85),
    &GetHsiValue( $m1, $m2, $h),
    &GetHsiValue( $m1, $m2, $h - 85)
  );
}

sub GetHsiValue {
  my ($n1, $n2, $hue) = @_;
  my ($value);
  
  $hue -= 255 if ($hue > 255);
  $hue += 255 if ($hue < 0);
  if ($hue < 42.5) {
    $value = $n1 + ($n2 - $n1) * ($hue / 42.5);
  } elsif ($hue < 127.5) {
    $value = $n2;
  } elsif ($hue < 170) {
    $value = $n1 + ($n2 - $n1) * ((170 - $hue) / 42.5);
  } else {
    $value = $n1;
  }
  
#  print "\nGetHsiValue($n1, $n2,$hue) = ", $value*255, "\n";

  return int($value * 255 + 0.5);
}


sub LoadSurfaces {
  my ($i);
  $BallSurface = new SDL::Surface( -name => "ball.png" );
  $DarkBallSurface = new SDL::Surface( -name => "ball.png" );
  $HexaSurface = new SDL::Surface( -name => "hexa.png" );
  $DarkHexaSurface = new SDL::Surface( -name => "hexa.png" );
  $GuySurface = new SDL::Surface( -name => "guy.png" );
  $HarpoonSurface = new SDL::Surface( -name => "harpoon.png" );
  $PopSurface = new SDL::Surface( -name => "pang.png" );
  $BorderSurface = new SDL::Surface( -name => "border.png" );
  
  &AlterPalette( $DarkBallSurface, sub { 1; }, sub { return $_[1] * 2 / 3, $_[2] * 2 / 3, $_[3] * 2 / 3; } );
  &AlterPalette( $DarkHexaSurface, sub { 1; }, sub { return $_[1] * 2 / 3, $_[2] * 2 / 3, $_[3] * 2 / 3; } );
  return;

  &AlterPalette( $BallSurface, sub { 1; }, 
    sub {
      shift @_;
      my ($h, $s, $i) = &RgbToHsi(@_);
      return &HsiToRgb(45, 255, 40 + $i * 215 / 255); } );
  &AlterPalette( $PopSurface, sub { 1; }, 
    sub {
      shift @_;
      my ($h, $s, $i) = &RgbToHsi(@_);
      return &HsiToRgb(45, 255, 40 + $i * 215 / 255); } );

}

sub AlterPalette {
  my ($surface, $filterSub, $alterSub) = @_;
  my ($r, $g, $b);
  my ($palette, $numColors, $n, $color);
  
  $palette = $surface->palette();
  $numColors = SDL::PaletteNColors($palette);
  for ($n = 0; $n < $numColors; ++$n) {
    $color = SDL::PaletteColors($palette, $n);
    ($r, $g, $b) = ( SDL::ColorR($color), SDL::ColorG($color), SDL::ColorB($color) );
    
    next unless $filterSub->($n, $r, $g, $b);
    ($r, $g, $b) = $alterSub->($n, $r, $g, $b);
    
    SDL::PaletteColors($palette, $n, $r, $g, $b);
  }
}

sub RenderBorder {
  my ($borderSurface, $targetSurface, $x, $y, $width, $height) = @_;
  my ($dstrect, $srcrect1, $srcrect2, $xpos, $ypos);
  
  # Draw top and bottom border
  
  $dstrect = new SDL::Rect( -width => 32, -height =>16);
  $srcrect1 = new SDL::Rect( -width => 32, -height =>16, -x => 32, -y => 0);
  $srcrect2 = new SDL::Rect( -width => 32, -height =>16, -x => 32, -y => 80);
  for ($xpos = 32; $xpos < $width-32; $xpos += 32) {
    $dstrect->x($xpos + $x);
    $dstrect->y($y);
    $borderSurface->blit($srcrect1, $targetSurface, $dstrect);
    $dstrect->y($y + $height - 16);
    $borderSurface->blit($srcrect2, $targetSurface, $dstrect);
  }
  
  # Draw left and right border
  $dstrect->width(16);
  $dstrect->height(32);
  $srcrect1->DESTROY();
  $srcrect2->DESTROY();
  $srcrect1 = new SDL::Rect( -width => 16, -height =>32, -x => 0, -y => 32);
  $srcrect2 = new SDL::Rect( -width => 16, -height =>32, -x => 80, -y => 32);
  for ($ypos = 32; $ypos < $height-32; $ypos += 32) {
    $dstrect->x($x);
    $dstrect->y($ypos + $y);
    $borderSurface->blit($srcrect1, $targetSurface, $dstrect);
    $dstrect->x($x + $width - 16);
    $borderSurface->blit($srcrect2, $targetSurface, $dstrect);
  }
  
  # Draw the borders
  $srcrect1->DESTROY();
  $srcrect2->DESTROY();
  $srcrect1 = new SDL::Rect( -width => 32, -height => 32 );
  $dstrect->width(32);
  $dstrect->x($x);
  $dstrect->y($y);
  $borderSurface->blit($srcrect1, $targetSurface, $dstrect);
  $srcrect1->x(64);
  $dstrect->x($x + $width - 32);
  $borderSurface->blit($srcrect1, $targetSurface, $dstrect);
  $srcrect1->y(64);
  $dstrect->y($y + $height - 32);
  $borderSurface->blit($srcrect1, $targetSurface, $dstrect);
  $srcrect1->x(0);
  $dstrect->x($x);
  $borderSurface->blit($srcrect1, $targetSurface, $dstrect);
}

sub LoadBackground {
  my $filename = shift;
  my ($backgroundImage, $srcrect, $dstrect);
  
  $backgroundImage = new SDL::Surface(-name => $filename);
  $dstrect = new SDL::Rect(-x => $ScreenMargin, -y => $ScreenMargin);
  $srcrect = new SDL::Rect(-width => $ScreenWidth, -height => $ScreenHeight);
  $backgroundImage->blit($srcrect, $Background, $dstrect);
}

##########################################################################
# SOUNDS
##########################################################################

sub LoadSounds {
  $Mixer = eval { SDL::Mixer->new(-frequency => 22050, -channels => 2, -size => 1024); };
  if ($@) {
    warn $@;
	return 0;
  }
  
  my ($soundName, $fileName);
  while (($soundName, $fileName) = each %Sounds) {
    $Sounds{$soundName} = new SDL::Sound($fileName);
  }
}

sub PlaySound {
  my $sound = shift;
  $Mixer and $Sounds{$sound} and $Mixer->play_channel(-1, $Sounds{$sound}, 0);
}


##########################################################################
# GAME MANAGEMENT
##########################################################################

sub SetGameLevel {
  my $level = shift;
  
  $GameLevel = $level;
  $GameLevelDesc = $GameLevels[$GameLevel];
  $GameSpeed = $GameLevelDesc->{gamespeed};
}

sub AdvanceGame {
  foreach my $gameObject (@GameObjects) {
    $gameObject->Advance();
  }
  &SpawnBalls() if $GamePause <= 0;
  --$GamePause if $GamePause > 0;
}

sub SpawnBalls {
  --$SpawnDelay;
  while ($SpawnDelay < 0) {
    my $ballname = $GameLevelDesc->{balls}->[ rand( scalar @{$GameLevelDesc->{balls}} ) ];
    my ($balldesc) = grep( $_->{name} eq $ballname, @BallDesc);
    next unless $balldesc;
    push @GameObjects, ( new DarkBall($balldesc, rand(600), rand(40) < 20 ? 0 : 1) );
    $SpawnDelay = $GameLevelDesc->{spawndelay} * $balldesc->{spawndelay} * 100;
  }
}

sub HandleEvents {
  my ($event, $type);

  $event = new SDL::Event;
  while (1) {
    last unless $event->poll();
    $type = $event->type();
   
    if ($type == SDL_QUIT) {
      exit;
    }
    elsif ($type == SDL_KEYDOWN) {
      my $keypressed = $event->key_sym;
      $Keys{$keypressed} = 1;
      $Events{$keypressed} = 1;
      if ($keypressed == SDLK_ESCAPE) {
        exit;
      }
      if ($keypressed == SDLK_w) {
        $::App->save_bmp("screenshot.bmp");
      }
    }
    elsif ($type == SDL_KEYUP) {
      my $keypressed = $event->key_sym;
      $Keys{$keypressed} = 0;
    }
  }
}

sub DrawGame {
  my ($gameObject);
  foreach $gameObject (@GameObjects) {
    $gameObject->Clear();
  }  
  foreach $gameObject (@GameObjects) {
    $gameObject->Draw();
  }
  $App->sync();
}

my $sdlFlags = SDL_ANYFORMAT | SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_HWACCEL | SDL_ASYNCBLIT;

$App = new SDL::App
  -flags => $sdlFlags,
  -title => "UPiPang", 
						-width => $PhysicalScreenWidth, 
						-height => $PhysicalScreenHeight;
#						-fullscreen => 1;

$Background = new SDL::Surface( 
  -name =>'',
  -flags=>SDL_SWSURFACE,
  -width => $App->width,
  -height => $App->height,
  -depth => 32,
  -Amask => '0 but true');

my $font = new SDL::Font("brandybun3.png");

&LoadSurfaces();
&LoadSounds();
&RenderBorder($BorderSurface, $Background, 0, 0, $PhysicalScreenWidth, $ScreenHeight + 2 * $ScreenMargin);
&LoadBackground('desert2.gif');
$Background->blit(0, $App, 0);
$GameSpeed = 1;
$GamePause = 0;
$SpawnDelay = 0;
&SetGameLevel(0);
my $guy = new Guy(0);

push @GameObjects, (
	$guy,
#	new DarkBall($BallDesc[0], rand(600), 0),
#	new DarkBall($BallDesc[2], rand(600), 1),
#	new DarkBall($BallDesc[4], rand(600), 1),
#	new DarkBall($BallDesc[5], rand(600), 0),
#	new DarkBall($BallDesc[9], rand(600), 1),
#	new DarkBall($BallDesc[10], rand(600), 0),
);

&GameTimer::ResetTimer();

while (1) {
#  $GameSpeed += 0.0001;
  
  # Calculate advance (how many game updates to perform)
  # Internally we run at 50 advances / sec
  
  my $advance = &GameTimer::GetAdvances();
  if ($advance <= 0) {
    $App->delay(10);
    next;
  } elsif ($advance > 10) {
    print STDERR "advance = $advance!\n";
    $advance = 10;
  }
  
  # Advance the game
  
  %Events = ();
  &HandleEvents();
  while ($advance--) {
    %GameEvents = ();
    &AdvanceGame();
    if ($GameEvents{magic}) {
      $GamePause = 200 if $GamePause < 200;
      push @GameObjects, (new GamePause);
    }
  }
  
  if ($guy->{killed}) {
    &DrawGame();
    &PlaySound('death');
    
    $guy->{x} = 300;
    $guy->{invincible} = 100;
    $guy->{killed} = 0;
    $App->delay(1000);
    $guy->DeleteHarpoons;
    &GameTimer::ResetTimer();
  }

  &DrawGame();
  $App->print(10, 550, "{azt hiszem|mukodik}");
}
